
Program Students_Average;

Type
    studrec = Record  {}
       name: string[20];
       numgr: integer;
       marks: array[1..4] Of byte;
    End;

    groupdata = Record  {}
       groupnumber: integer;
       { .      -}

       numstuds: integer;
       {    }

       avg: real;
       {   ,    }
    End;

Const
  MAXGROUPS = 20;
  {. -  }

Var
  groups: array[1..MAXGROUPS] Of groupdata;
  { }

  used_groups: byte;
  {         groups}

  the_stud: studrec;
  { ,   }

  studfile: file Of studrec;


function CalcStudAverage (StudentRec: studrec): real;
var
  j: byte;
  avg : real;

begin
     With StudentRec Do
     begin
          avg := 0;
          for j := 1 to 4 do
              avg := avg + marks[j];
          avg := avg / 4.0;
     end;
     CalcStudAverage := avg;
end;


Procedure add_stud (Var stud: studrec);
Var
  i, j: byte;

Begin
  i := 1;
  while i <= used_groups Do
  Begin {  }
       If groups[i].groupnumber = stud.numgr Then
          break;  {  ,  }
       inc (i);
  End;

  If i > used_groups Then
    Begin {     }
      If used_groups = MAXGROUPS Then
        Begin {, }
          writeln ('There are more than ', MAXGROUPS, ' different groups, exiting.');
          close (studfile);
          halt (9);
        End;
      inc (used_groups); {  }
      With groups[i] Do
        Begin { }
          groupnumber := stud.numgr;
          numstuds := 1; {1 }
          avg := CalcStudAverage (stud); { . }
        End;
    End
  Else
  With groups[i] Do
  Begin
    inc (numstuds); {  }
    avg := CalcStudAverage (stud);
   { .  ,  AVG   . ,      -   }
  End;
End;


Procedure CalcGroupAverage;
{ .  ,   -   }
Var
  i: byte;

Begin
  For i := 1 To used_groups Do
  with groups[i] do
    avg := avg / numstuds;
End;


Procedure outputhighest;
{     . . }
Var
  maxavg: real;
  i, maxi: byte;

Begin
  If groups[1].numstuds = 0 Then
    Begin
      writeln ('No students, nothing to output!');
      exit
    End;
  maxavg := groups[1].avg; { }
  maxi := 1;   {    }
  For i := 2 To used_groups Do
    Begin    { }
      If groups[i].avg > maxavg Then
        Begin  {  - }
          maxi := i;
          maxavg := groups[i].avg;
        End;
    End;
  writeln ('Group with maximal average marks is ', groups[maxi].groupnumber,
          ', average is ', groups[maxi].avg : 0 : 2);  {  . . }
  readln;
End;


Begin { main program }
  used_groups := 0;      { }
  groups[1].numstuds := 0;

  assign (studfile, 'students.dat');
  {$i-}
  reset (studfile);    {  }
  {$i+}
  If IOresult <> 0 Then
    Begin       {, }
      writeln ('Cannot open datafile!');
      halt (2)
    End;

  while not eof (studfile) Do
  Begin  {  }
    read (studfile, the_stud);
    add_stud (the_stud);             {   ,   }
  End;

  close (studfile);    {  ,  }

  CalcGroupAverage; { . }
  outputhighest; {   }
End.